ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
Revision: 1.71
Committed: Sat Feb 7 21:40:54 2009 UTC (15 years, 3 months ago) by root
Branch: MAIN
CVS Tags: rel-2_80, rel-2_79, rel-2_78
Changes since 1.70: +3 -2 lines
Log Message:
*** empty log message ***

File Contents

# Content
1 #!@PERL@
2
3 use strict;
4
5 my $prefix = "@prefix@";
6 my $exec_prefix = "@exec_prefix@";
7 my $datarootdir = "@datarootdir@";
8 my $DATADIR = "@datadir@/@PACKAGE@";
9
10 my $CONVERT = "@CONVERT@";
11 #my $IDENTIFY = "@IDENTIFY@";
12 my $OPTIPNG = "@OPTIPNG@";
13 my $RSYNC = "@RSYNC@";
14 my $PNGNQ = "@PNGNQ@";
15
16 use Getopt::Long;
17 use Coro::EV;
18 use AnyEvent;
19 use YAML ();
20 use JSON::XS ();
21 use IO::AIO ();
22 use File::Temp;
23 use Deliantra;
24 use Coro 5.12;
25 use Coro::AIO;
26 use Coro::Util;
27 use POSIX ();
28 use Carp;
29 use Coro::Channel;
30 use Coro::Storable; $Storable::canonical = 1;
31
32 $SIG{QUIT} = sub { Carp::cluck "QUIT" };
33
34 sub usage {
35 warn <<EOF;
36 Usage: cfutil [-v] [-q] [--force] [--cache]
37 [--install-arch path]
38 [--install-maps maps]
39 [--print-statedir]
40 [--print-confdir]
41 [--print-datadir]
42 [--print-libdir]
43 [--print-bindir]
44 EOF
45 exit 1;
46 }
47
48 my $VERBOSE = 1;
49 my $CACHE = 0;
50 my $FORCE;
51 my $TMPDIR = "/tmp/cfutil$$~";
52 my $TMPFILE = "aaaa0";
53
54 our %COLOR = (
55 black => 0,
56 white => 1,
57 navy => 2,
58 red => 3,
59 orange => 4,
60 blue => 5,
61 darkorange => 6,
62 green => 7,
63 lightgreen => 8,
64 grey => 9,
65 brown => 10,
66 gold => 11,
67 tan => 12,
68 );
69
70 END { system "rm", "-rf", $TMPDIR }
71
72 my $s_INT = EV::signal INT => sub { exit 1 };
73 my $s_TERM = EV::signal TERM => sub { exit 1 };
74
75 mkdir $TMPDIR, 0700
76 or die "$TMPDIR: $!";
77
78 sub fork_sub(&) {
79 my ($cb) = @_;
80
81 if (my $pid = fork) {
82 my $current = $Coro::current;
83 my $w = AnyEvent->child (pid => $pid, cb => sub { $current->ready });
84 Coro::schedule;
85 } else {
86 eval { $cb->() };
87 POSIX::_exit 0 unless $@;
88 warn $@;
89 POSIX::_exit 1;
90 }
91 }
92
93 sub inst_maps($) {
94 my (undef, $path) = @_;
95
96 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
97
98 if (!-f "$path/regions") {
99 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
100 exit 1 unless $FORCE;
101 }
102
103 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
104 "$path/.", "$DATADIR/maps/.",
105 "--exclude", "CVS", "--exclude", "/world-precomposed",
106 "--delete", "--delete-excluded"
107 and die "map installation failed.\n";
108
109 print "maps installed successfully.\n";
110 }
111
112 {
113 our %ANIMINFO;
114 our %FACEINFO;
115 our %RESOURCE;
116 our @ARC;
117 our %ARC;
118 our $TRS;
119 our $NFILE;
120 our $PATH;
121
122 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
123
124 our $c_arc = new Coro::Channel;
125 our $c_trs = new Coro::Channel;
126 our $c_res = new Coro::Channel;
127
128 our @c_png;
129
130 sub commit_png($$$) {
131 my ($name, $data, $T) = @_;
132
133 $FACEINFO{$name}{"data$T"} = $data;
134 }
135
136 sub process_png {
137 while (@c_png) {
138 my ($path, $delete) = @{pop @c_png};
139
140 my $png;
141 aio_lstat $path;
142 my ($size, $mtime) = (stat _)[7,9];
143
144 if (0 > aio_load $path, $png) {
145 warn "$path: $!, skipping.\n";
146 next;
147 }
148
149 my $stem = $path;
150 my $T;
151
152 if ($stem =~ s/\.32x32\.png~?$//) {
153 $T = 32;
154 } elsif ($stem =~ s/\.64x64\.png~?$//) {
155 $T = 64;
156 } else {
157 warn "$path: weird filename, skipping.\n";
158 next;
159 }
160
161 # quickly extract width and height of the (necessarily PNG) image
162 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
163 warn "$path: not a recognized png file, skipping.\n";
164 next;
165 }
166
167 my ($w, $h) = unpack "NN", $1;
168
169 if ($w < $T || $h < $T) {
170 warn "$path: too small ($w $h), skipping.\n";
171 next;
172 }
173
174 if ($w % $T || $h % $T) {
175 warn "$path: weird png size ($w $h), skipping.\n";
176 next;
177 }
178
179 (my $base = $stem) =~ s/^.*\///;
180
181 my $fi = $FACEINFO{$base};
182 unless ($fi) {
183 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
184 #next;
185 }
186
187 my $arc = $fi->{arc} || { };
188
189 unless ($path =~ /~$/) {
190 # possibly enlarge
191 if (0 > aio_stat "$stem.64x64.png") {
192 my $other = "$stem.64x64.png~";
193
194 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
195 fork_sub {
196 my $CROP;
197 my $SRC = "png:\Q$path\E";
198
199 my $is_floor = $arc->{is_floor};
200 my $is_wall = 0;
201
202 my ($wall_pfx, $wall_dir, $wall_sfx);
203
204 if (
205 !$is_floor
206 && !$arc->{alive}
207 && $arc->{move_block} eq "all"
208 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
209 ) {
210 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
211
212 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
213 $is_wall = 1;
214 }
215 }
216
217 if ($is_wall || $is_floor) {
218 # add a 4px border and add other images around it
219 $CROP = "-shave 8x8 +repage";
220
221 $w += 8;
222 $h += 8;
223
224 $SRC = "-size ${w}x${h} xc:transparent";
225 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
226
227 # 8 surrounding images
228 for (
229 # x y b r0 r1
230 [-1, -1, 0, 6],
231 [ 0, -1, 1, 10, 14],
232 [+1, -1, 0, 12],
233
234 [-1, 0, 8, 5, 7],
235 #
236 [+1, 0, 2, 5, 13],
237
238 [-1, +1, 0, 3],
239 [ 0, +1, 4, 10, 11],
240 [+1, +1, 0, 9],
241 ) {
242 my ($x, $y, $d, $r0, $r1) = @$_;
243
244 my $tile = $is_floor ? $path
245 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
246 : die;
247
248 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
249 "\Q$tile",
250 $x * ($w - 8) + 4,
251 $y * ($h - 8) + 4;
252 }
253 }
254
255 system "convert -depth 8 $SRC rgba:-"
256 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
257 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
258 and die "convert/cfhq2xa pipeline error: status $? ($!)";
259 system $OPTIPNG, "-i0", "-q", "$other~";
260 die "$other~ has zero size, aborting." unless -s "$other~";
261 rename "$other~", $other;
262 };
263 }
264
265 push @c_png, [$other, !$CACHE];
266 }
267
268 # possibly scale down
269 if (0 > aio_stat "$stem.32x32.png") {
270 my $other = "$stem.32x32.png~";
271
272 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
273 fork_sub {
274 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
275 system $OPTIPNG, "-i0", "-q", "$other~";
276
277 # reduce smoothfaces >10000 bytes
278 # obsolete, no longer required
279 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
280 my $ncolor = 256;
281 while () {
282 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
283 system $OPTIPNG, "-i0", "-q", "$other~~";
284 last if 10000 > -s "$other~~";
285 $ncolor = int $ncolor * 0.9;
286 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
287 }
288
289 printf "reduced %s from %d to %d bytes using %d colours.\n",
290 $other, -s "$other~", -s "$other~~", $ncolor
291 if $VERBOSE >= 2;
292 rename "$other~~", "$other~";
293 }
294
295 die "$other~ has zero size, aborting." unless -s "$other~";
296 rename "$other~", $other;
297 };
298 }
299
300 #warn "scaled down $path to $other\n";#d#
301 push @c_png, [$other, !$CACHE];
302 }
303 }
304
305 (my $face = $stem) =~ s/^.*\///;
306
307 # split all bigfaces, but avoid smoothfaces (*_S)
308 if (($w > $T || $h > $T) && $face !~ /_S\./) {
309 # split
310 my @tile;
311 for my $x (0 .. (int $w / $T) - 1) {
312 for my $y (0 .. (int $h / $T) - 1) {
313 my $file = "$path+$x+$y~";
314 aio_lstat $file;
315 push @tile, [$x, $y, $file, (stat _)[9]];
316 }
317 }
318
319 my $mtime = (lstat $path)[9];
320 my @todo = grep { $_->[3] <= $mtime } @tile;
321 if (@todo) {
322 fork_sub {
323 open my $convert, "|-", $CONVERT,
324 "png:-",
325 (map {
326 (
327 "(",
328 "+clone",
329 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
330 "+repage",
331 -quality => "00",
332 -write => "png32:$_->[2]~",
333 "+delete",
334 ")",
335 )
336 } @todo),
337 "null:";
338
339 binmode $convert;
340 print $convert $png;
341 close $convert;
342
343 # pass 2, optimise, and rename
344 for (@todo) {
345 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
346 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
347 rename "$_->[2]~", $_->[2];
348 }
349 };
350 }
351
352 for (@tile) {
353 my ($x, $y, $file) = @$_;
354 my $tile;
355
356 if (0 > aio_load $file, $tile) {
357 die "$path: unable to read tile +$x+$y, aborting.\n";
358 }
359 IO::AIO::aio_unlink $file unless $CACHE;
360 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
361 }
362 } else {
363 # use as-is (either small, use smooth)
364 commit_png $face, $png, $T;
365 }
366
367 aio_unlink $path if $delete;
368 }
369 }
370
371 sub process_arc {
372 while (my $job = $c_arc->get) {
373 my ($dir, $file) = @$job;
374
375 my $arc;
376 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
377
378 my $arc = read_arch "$dir/$file";
379 for my $o (values %$arc) {
380 push @ARC, $o;
381 for (my $m = $o; $m; $m = $m->{more}) {
382 $ARC{$m->{_name}} = $m;
383 }
384
385 $o->{editor_folder} = $dir;
386
387 my $visibility = delete $o->{visibility};
388 my $magicmap = delete $o->{magicmap};
389
390 # find upper left corner :/
391 # omg, this is sooo broken
392 my ($dx, $dy);
393 for (my $o = $o; $o; $o = $o->{more}) {
394 $dx = $o->{x} if $o->{x} < $dx;
395 $dy = $o->{y} if $o->{y} < $dy;
396 }
397
398 for (my $o = $o; $o; $o = $o->{more}) {
399 my $x = $o->{x} - $dx;
400 my $y = $o->{y} - $dy;
401
402 my $ext = $x|$y ? "+$x+$y" : "";
403
404 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
405
406 $visibility = delete $o->{visibility} if exists $o->{visibility};
407 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
408
409 my $anim = delete $o->{anim};
410
411 if ($anim) {
412 # possibly add $ext to the animation name to avoid
413 # the need to specify archnames for all parts
414 # of a multipart archetype.
415 $o->{animation} = "$o->{_name}";
416 my $facings = 1;
417 my @frames;
418
419 for (@$anim) {
420 if (/^facings\s+(\d+)/) {
421 $facings = $1*1;
422 } elsif (/^blank.x11$|^empty.x11$/) {
423 push @frames, $_;
424 } else {
425 push @frames, "$_$ext";
426 }
427 }
428
429 $ANIMINFO{$o->{animation}} = {
430 facings => $facings,
431 frames => \@frames,
432 };
433 }
434
435 for ($o->{face} || (), @{$anim || []}) {
436 next if /^facings\s/;
437
438 my $face = $_;
439 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
440
441 my $info = $FACEINFO{$face} ||= { };
442 $info->{arc} = $o;
443
444 next if $face =~ /^blank.x11$|^empty.x11$/;
445
446 $info->{visibility} = $visibility if defined $visibility;
447 $info->{magicmap} = $magicmap if defined $magicmap;
448 }
449
450 if (my $smooth = delete $o->{smoothface}) {
451 my %kv = split /\s+/, $smooth;
452 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
453 while (my ($face, $smooth) = each %kv) {
454 $FACEINFO{$smooth}{arc} = $o;
455
456 $FACEINFO{$face}{smooth} = $smooth;
457 $FACEINFO{$face}{smoothlevel} = $level;
458 }
459 }
460 }
461 }
462 }
463 }
464
465 sub process_trs {
466 while (my $job = $c_trs->get) {
467 my ($dir, $file) = @$job;
468 my $path = "$dir/$file";
469
470 my $trs;
471 if (0 > aio_load $path, $trs) {
472 warn "$path: $!, skipping.\n";
473 next;
474 }
475
476 $TRS .= $trs;
477 }
478 }
479
480 my %FILECACHE;
481
482 sub load_cached($;$) {
483 unless (exists $FILECACHE{$_[0]}) {
484 my $data;
485 if (0 < aio_load $_[0], $data) {
486 if ($_[1]) {
487 $data = eval { $_[1]->($data) };
488 warn "$_[0]: $@" if $@;
489 }
490 }
491
492 $FILECACHE{$_[0]} = $data;
493 }
494
495 $FILECACHE{$_[0]}
496 }
497
498 sub process_res {
499 while (my $job = $c_res->get) {
500 my ($dir, $file, $type) = @$job;
501
502 my $data;
503 aio_load "$dir/$file", $data;
504
505 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
506
507 utf8::decode $dir;
508 utf8::decode $file;
509
510 # a meta file for resources is now mandatory
511 unless (exists $meta->{$file}) {
512 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
513 next;
514 }
515
516 $meta = {
517 %{ $meta->{"" } || {} },
518 %{ $meta->{$file} || {} },
519 };
520
521 if ($meta->{license} =~ s/^#//) {
522 $meta->{license} = ({
523 "pd" => "Public Domain",
524 "gpl" => "GNU General Public License, version 3.0 or any later",
525 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
526 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
527 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
528 })->{$meta->{license}}
529 || warn "$dir/$file: license tag '$meta->{license}' not found.";
530 }
531
532 $file =~ s/\.res$//;
533 $file =~ s/\.(ogg|wav|jpg|png)$//;
534
535 substr $dir, 0, 1 + length $PATH, "";
536
537 if (my $filter = $meta->{cfutil_filter}) {
538 if ($filter eq "yaml2json") {
539 $data = JSON::XS::encode_json YAML::Load $data;
540 } elsif ($filter eq "json2json") {
541 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
542 } elsif ($filter eq "perl2json") {
543 $data = eval $data; die if $@;
544 $data = JSON::XS::encode_json $data;
545 } else {
546 warn "$dir/$file: unknown filter $filter, skipping\n";
547 }
548 }
549
550 $RESOURCE{"$dir/$file"} = {
551 type => (exists $meta->{type} ? delete $meta->{type} : $type),
552 data => $data,
553 %$meta ? (meta => $meta) : (),
554 };
555 }
556 }
557
558 sub find_files;
559 sub find_files {
560 my ($path) = @_;
561
562 IO::AIO::aioreq_pri 4;
563 IO::AIO::aio_scandir $path, 4, sub {
564 my ($dirs, $nondirs) = @_;
565
566 find_files "$path/$_"
567 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
568
569 my $dir = $path;
570 substr $dir, 0, 1 + length $PATH, "";
571
572 for my $file (@$nondirs) {
573 if ($dir =~ /^music(?:\/|$)/) {
574 $c_res->put ([$path, $file, 3]) # FT_MUSIC
575 if $file =~ /\.(ogg)$/;
576
577 } elsif ($dir =~ /^sound(?:\/|$)/) {
578 $c_res->put ([$path, $file, 5]) # FT_SOUND
579 if $file =~ /\.(wav|ogg)$/;
580
581 } elsif ($dir =~ /^res(?:\/|$)/) {
582 if ($file =~ /\.(jpg|png)$/) {
583 $c_res->put ([$path, $file, 0]) # FT_FACE
584 } elsif ($file =~ /\.(res)$/) {
585 $c_res->put ([$path, $file, 6]) # FT_RSRC
586 } else {
587 $c_res->put ([$path, $file, undef]);
588 }
589
590 } elsif ($file =~ /\.png$/) {
591 push @c_png, ["$path/$file", 0];
592
593 } elsif ($file =~ /\.trs$/) {
594 $c_trs->put ([$path, $file]);
595
596 } elsif ($file =~ /\.arc$/) {
597 $c_arc->put ([$path, $file]);
598
599 } else {
600 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
601 }
602 }
603 };
604 }
605
606 sub inst_arch($) {
607 my (undef, $path) = @_;
608
609 $PATH = $path;
610
611 print "\n",
612 "Installing '$path' to '$DATADIR'\n",
613 "\n",
614 "This can take a long time if you run this\n",
615 "for the first time or do not use --cache.\n",
616 "\n",
617 "Unless you run verbosely, all following warning\n",
618 "or error messages indicate serious problems.\n",
619 "\n";
620
621 if (!-d "$path/treasures") {
622 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
623 exit 1 unless $FORCE;
624 }
625
626 print "scanning files...\n" if $VERBOSE;
627
628 find_files $path;
629
630 my @a_arc = map +(async \&process_arc), 1..2;
631 my @a_res = map +(async \&process_res), 1..2;
632 my @a_trs = map +(async \&process_trs), 1..2;
633
634 IO::AIO::flush;
635
636 $c_res->shutdown;
637 $c_arc->shutdown;
638 $c_trs->shutdown;
639
640 print "start file scan, arc, res processing...\n" if $VERBOSE;
641
642 $_->join for @a_arc; # need to parse all archetypes before png processing
643
644 print "end arc, start png processing...\n" if $VERBOSE;
645
646 # eight png crunchers work fine for my 4x smp machine
647 my @a_png = map +(async \&process_png), 1..8;
648
649 $_->join for (@a_trs, @a_res, @a_png);
650
651 print "scanning done, processing results...\n" if $VERBOSE;
652 {
653 # remove path prefix from editor_folder
654 substr $_->{editor_folder}, 0, 1 + length $path, ""
655 for values %ARC;
656
657 print "resolving inheritance tree...\n" if $VERBOSE;
658 # resolve inherit
659 while () {
660 my $progress;
661 my $loop;
662
663 for my $o (values %ARC) {
664 if (my $other = $o->{inherit}) {
665 if (my $s = $ARC{$other}) {
666 if ($s->{inherit}) {
667 $loop = $s;
668 } else {
669 delete $o->{inherit};
670 my %s = %$s;
671 delete @s{qw(_name more name name_pl)};
672 %$o = ( %s, %$o );
673 ++$progress;
674 }
675 } else {
676 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
677 delete $ARC{$o->{_name}};
678 }
679 }
680 }
681
682 unless ($progress) {
683 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
684 if $loop;
685
686 last;
687 }
688 }
689
690 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
691 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
692
693 print "writing archetypes...\n" if $VERBOSE;
694 open my $fh, ">:utf8", "$DATADIR/archetypes~"
695 or die "$DATADIR/archetypes~: $!";
696 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
697 }
698
699 {
700 print "writing treasures...\n" if $VERBOSE;
701 open my $fh, ">:utf8", "$DATADIR/treasures~"
702 or die "$DATADIR/treasures~: $!";
703 print $fh $TRS;
704 }
705
706 {
707 print "processing facedata...\n" if $VERBOSE;
708 while (my ($k, $v) = each %FACEINFO) {
709 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
710 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
711
712 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
713 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
714
715 if (my $magicmap = $v->{magicmap}) {
716 $magicmap =~ y/A-Z_\-/a-z/d;
717 $v->{magicmap} = $COLOR{$magicmap};
718 }
719
720 delete $v->{arc};
721 }
722
723 print "writing facedata...\n" if $VERBOSE;
724 open my $fh, ">:perlio", "$DATADIR/facedata~"
725 or die "$DATADIR/facedata~: $!";
726
727 print $fh freeze {
728 version => 2,
729 faceinfo => \%FACEINFO,
730 animinfo => \%ANIMINFO,
731 resource => \%RESOURCE,
732 };
733 }
734
735 print "committing files...\n" if $VERBOSE;
736
737 for (qw(archetypes facedata treasures)) {
738 chmod 0644, "$DATADIR/$_~";
739 rename "$DATADIR/$_~", "$DATADIR/$_"
740 or die "$DATADIR/$_: $!";
741 }
742
743 print "archetype data installed successfully.\n";
744 }
745 }
746
747 Getopt::Long::Configure ("bundling", "no_ignore_case");
748 GetOptions (
749 "verbose|v:+" => \$VERBOSE,
750 "cache" => \$CACHE,
751 "quiet|q" => sub { $VERBOSE = 0 },
752 "force" => sub { $FORCE = 1 },
753 "install-arch=s" => \&inst_arch,
754 "install-maps=s" => \&inst_maps,
755 "print-statedir" => sub { print "@pkgstatedir@\n" },
756 "print-datadir" => sub { print "$DATADIR\n" },
757 "print-confdir" => sub { print "@pkgconfdir@\n" },
758 "print-libdir" => sub { print "@libdir@/@PACKAGE@\n" },
759 "print-bindir" => sub { print "@bindir@/@PACKAGE@\n" },
760 ) or usage;
761